//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_color4  PaleVioletRed
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern int  EmaFastPeriod = 12;
extern int  EmaSlowPeriod = 26;
extern int  EmaPrice      = PRICE_CLOSE;
extern bool ViewAsCandles = false;
extern int  WickWidth     = 1;
extern int  BodyWidth     = 2;

double vwemawu[];
double vwemawd[];
double vwemabu[];
double vwemabd[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   int type = DRAW_NONE; if (ViewAsCandles) type = DRAW_HISTOGRAM;
   SetIndexBuffer(0,vwemawu); SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,WickWidth);
   SetIndexBuffer(1,vwemawd); SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,WickWidth);
   SetIndexBuffer(2,vwemabu); SetIndexStyle(2,type          ,EMPTY,BodyWidth);
   SetIndexBuffer(3,vwemabd); SetIndexStyle(3,type          ,EMPTY,BodyWidth);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][8];
#define _price 0
#define _ema10 1
#define _ema11 2
#define _ema12 3
#define _ema20 4
#define _ema21 5
#define _ema22 6
#define _trend 7
int start()
{
   int i,r,count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
    
      double alphaFast = 2.0/(EmaFastPeriod+1.0);
      double alphaSlow = 2.0/(EmaSlowPeriod+1.0);
      
      //
      //
      //
      //
      //
      
      for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,EmaPrice,i);
            work[r][_ema10] = work[r-1][_ema10]+alphaFast*(Volume[i]*price-work[r-1][_ema10]);
            work[r][_ema11] = work[r-1][_ema11]+alphaFast*(Volume[i]      -work[r-1][_ema11]);
            work[r][_ema12] = work[r][_ema10]/work[r][_ema11];
            work[r][_ema20] = work[r-1][_ema20]+alphaSlow*(Volume[i]*price-work[r-1][_ema20]);
            work[r][_ema21] = work[r-1][_ema21]+alphaSlow*(Volume[i]      -work[r-1][_ema21]);
            work[r][_ema22] = work[r][_ema20]/work[r][_ema21];
            work[r][_trend] = work[r-1][_trend];

               if (work[r][_ema12]>work[r][_ema22]) work[r][_trend]= 1;
               if (work[r][_ema12]<work[r][_ema22]) work[r][_trend]=-1;
               if (work[r][_trend]==1)
               {
                  vwemawu[i] = High[i];
                  vwemawd[i] = Low[i];
                  vwemabu[i] = MathMax(Open[i],Close[i]);
                  vwemabd[i] = MathMin(Open[i],Close[i]);
               }
               if (work[r][_trend]==-1)
               {
                  vwemawd[i] = High[i];
                  vwemawu[i] = Low[i];
                  vwemabd[i] = MathMax(Open[i],Close[i]);
                  vwemabu[i] = MathMin(Open[i],Close[i]);
               }
      }
   return(0);
}